import cv2
import os
import glob
import numpy as np
from PIL import Image
from lib.utils import *

# YS Image generator
# src_path, x, y , w, h, label
trainfile = r'/home/mp/Chainer/train.txt'
labels = ['upper-body', 'lower-body', 'full-body']

with open(trainfile, 'r') as f:
    lines = [i.strip().strip('\n') for i in f.readlines()]

# image_array, x, y , w, h, label, one_hot
sample_data = []

def generate_samples(n_samples=16, width=416,height=416):
    data = []
    t = []
    for i in range(n_samples):
        line = lines[np.random.randint(len(lines))]
        src_path,x,y,w,h,label = line.split()
        x,y,w,h,label = float(x),float(y),float(w),float(h),int(label)

        img = Image.open(src_path)

        ori_w, ori_h = img.size


        if ori_w < ori_h: 
            img = img.resize((int(ori_w*height//ori_h),height))
            bg = Image.new('RGB',(width,height),(255,255,255))
            bg.paste(img,(0,0))
            x = x*ori_w/img.size[0]
            w = w*ori_w/img.size[0]
        else:
            img = img.resize((width,int(ori_h*width//ori_w)))
            bg = Image.new('RGB',(width,height),(255,255,255))
            bg.paste(img,(0,0))
            y = y*ori_h/img.size[1]
            h = w*ori_h/img.size[1]

        imgarray = np.array(bg)
        imgarray = np.asarray(imgarray, dtype=np.float32) / 255.0
        imgarray = imgarray.transpose(2, 0, 1)
        data.append(imgarray)
        
        t.append([
            {"x": int(x),
             "y": int(y),
             "w": int(w),
             "h": int(h),
             "label": label}
            ])
    data = np.array(data)
    return data, t
